/* -*- mia-c++  -*-
 *
 * This file is part of MIA - a toolbox for medical image analysis
 * Copyright (c) Leipzig, Madrid 1999-2017 Gert Wollny
 *
 * MIA is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MIA; if not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <mia/3d/filter.hh>

NS_BEGIN( tee_3dimage_filter)


class C3DTee : public mia::C3DFilter
{
public:
       C3DTee(const std::string& name);

       template <class T>
       C3DTee::result_type operator () (const mia::T3DImage<T>& data) const ;
private:
       virtual mia::P3DImage do_filter(const mia::C3DImage& image) const;
       virtual mia::P3DImage do_filter(mia::P3DImage image) const;
       std::string m_name;
};

class C3DTeeFilterPluginFactory: public mia::C3DFilterPlugin
{
public:
       C3DTeeFilterPluginFactory();
private:
       virtual mia::C3DFilter *do_create()const;
       virtual const std::string do_get_descr()const;
       std::string m_filename;
};

NS_END
